
/* omap3_serial_test.S
 *
 * (c) 2008, Dirk Behme, dirk.behme@gmail.com
 *
 * This small test application is loaded into internal
 * OMAP3 SRAM and there prints "Hello OMAP3" to UART3 in
 * infinite loop. I.e. after downloading via OMAP3 serial 
 * boot ROM you should be able to switch to terminal 
 * program, e.g. minicom, and there observe above output.
 *
 * ----------------------------------------------------------------------------
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *---------------------------------------------------------------------------*/

.text
.globl _start
_start:
	mov     r0, #'H'
	bl	putc
	mov     r0, #'e'
	bl	putc
	mov     r0, #'l'
	bl	putc
	mov     r0, #'l'
	bl	putc
	mov     r0, #'o'
	bl	putc
	mov     r0, #' '
	bl	putc
	mov     r0, #'O'
	bl	putc
	mov     r0, #'M'
	bl	putc
	mov     r0, #'A'
	bl	putc
	mov     r0, #'P'
	bl	putc
	mov     r0, #'3'
	bl	putc
	mov     r0, #'\r'
	bl	putc
	mov     r0, #'\n'
	bl	putc
	b       _start

putc:	ldr	r2,UART3_BASE
putc1:	ldrh	r1,[r2,#0x14]
	tst	r1,#0x20 
	beq	putc1
	strh	r0,[r2]
	mov     pc, lr

UART3_BASE:	.word 0x49020000
